<?php
// A vast majority of this code is written by Nick Vogt 
// https://www.h3xed.com
class amazonmws_sp_api_retry{
    
    private $IAM_USER_KEY;
    private $IAM_USER_SECRET;
    private $APP_LWA_ID;
    private $APP_LWA_SECRET;
    private $APP_REFRESH_TOKEN;
    private $USER_AGENT;
    private $HOST;
    private $ENDPOINT;
    private $MP_ID;
    private $TOKEN_CACHE;
    
    function amazonmws_sp_api_retry(){
        $this->IAM_USER_KEY = 'AKIA3FLDXKYAYCBL674A';
        $this->IAM_USER_SECRET = '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';
        $this->APP_LWA_ID = 'amzn1.application-oa2-client.4ab6ad74e3554a779228c6e6510791d0';
        $this->APP_LWA_SECRET = 'amzn1.oa2-cs.v1.22b7c9b6debeebde254d026dd4eb30ce6949b2e0de8a935b56115c85e0b9ed4d';
        $this->APP_REFRESH_TOKEN = 'Atzr|IwEBIFeoOCDocCuQCQyKIwGLV9cjcmCgkcvuZojg1lfzd1_ifG3CZ6hUWhumIz0RrF-fr1Nm_uj1xiyuhXNTySt5vcFmdasr1VwfkoYqP7rik890fz95poLmmmNUdypNYwi5xUruC23Z4pzQwDlU1j4dWhFw6Im5R2EQzt0fd8BQl5nRC4xUjaRiyCBhcp40y_rzzVKaRsIXT6xX9QdbEA0SmdqVF-_rp6C2AeCMYaVnsI1hL0M2nQqc8ZuWlLSz8UPQDybcdirSkXES1Zfr8jgoV_HDU8Kpbz-xK73RWwBdUDZYmvpXwZSg8AJGrjS-Fv8s0A8';   
        $this->USER_AGENT = 'My Pricing Tool/1.0 (Language=PHP)';
        $this->HOST = 'sellingpartnerapi-na.amazon.com';
        $this->ENDPOINT = 'https://' . $this->HOST;   
        $this->REGION =  'us-east-1';
        $this->MP_ID =  'ATVPDKIKX0DER';
        $this->TOKEN_CACHE = 'amazon-access-token.json';
    }
    
    function httpRequest($url, $post = '', $header = null, &$status = null) {
        //echo 'one';
        $ch = curl_init($url);
        curl_setopt_array($ch, [
            CURLOPT_SSL_VERIFYPEER => true, CURLOPT_SSL_VERIFYHOST => 2,
            CURLOPT_RETURNTRANSFER => true, CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_CONNECTTIMEOUT => 5,
        ]);
        if ($post) curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        if ($header) curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        $out = curl_exec($ch);
        if (curl_errno($ch)) exit('Error: ' . curl_error($ch));
        if ($status !== null) $status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        
        return $out;
        //echo 'two';
    }
    
    function getAccessToken() {

        // Return existing access token if exists and not expired
        if (file_exists($this->TOKEN_CACHE)) {
            $file = file_get_contents($this->TOKEN_CACHE);
            $json = json_decode($file, true);
            if ($json && !empty($json['token'])) {
                if (!empty($json['expires']) && time() < $json['expires']) {
                    return $json['token'];
                }
            }
        }

        // Otherwise get new access token
        $post = 'grant_type=refresh_token&refresh_token=' . $this->APP_REFRESH_TOKEN
              . '&client_id=' . $this->APP_LWA_ID . '&client_secret=' . $this->APP_LWA_SECRET;
        $url = 'https://api.amazon.com/auth/o2/token';
        $response = $this->httpRequest($url, $post, ['user-agent:' . $this->USER_AGENT]);

        // Validate new access token response
        if (strpos($response, '{"access_token":') !== 0) {
            exit('Error: Access token response was bad: ' . $response);
        }
        if (strpos($response, 'expires_in') === false) {
            exit('Error: No "expires_in" found in response: ' . $response);
        }
        $json = json_decode($response, true);
        if (!$json || empty($json['access_token']) || empty($json['expires_in'])) {
            exit('Error: Access token JSON decode failure: ' . $response);
        }

        // Cache access token with an expires timestamp
        $cacheData = json_encode([
            'token' => $json['access_token'],
            'expires' => time() + $json['expires_in'],
        ]);

        return $json['access_token'];
    }    
    
    function amazonRequest($method, $path, $qs = '', $post = '') {

        // Get access token
        $accessToken = $this->getAccessToken();

        // Two formats for date used throughout the function, in GMT.
        // Make sure your server's time is accurate or else requests may fail.
        $date = gmdate('Ymd\THis\Z');
        $ymd = gmdate('Ymd');

        // Build a canonical request. This is just a highly-structured and
        // ordered version of the request you will be making. Each part is
        // newline-separated. The number of headers is variable, but this
        // uses four headers. Headers must be in alphabetical order.
        $canonicalRequest = $method . "\n" // HTTP method
        . $path . "\n" //  Path component of the URL
        . $qs . "\n" // Query string component of the URL (without '?')
        . 'host:' . $this->HOST . "\n" // Header
        . 'user-agent:' . $this->USER_AGENT . "\n" // Header
        . 'x-amz-access-token:' . $accessToken . "\n" // Header
        . 'x-amz-date:' . $date . "\n" // Header
        . "\n" // A newline is needed here after the headers
        . 'host;user-agent;x-amz-access-token;x-amz-date' . "\n" // Header names
        . hash('sha256', $post); // Hash of the payload (empty string okay)
        
        // Create signing key, which is hashed four times, each time adding
        // more data to the key. Don't ask me why Amazon does it this way.
        $signKey = hash_hmac('sha256', $ymd, 'AWS4' . $this->IAM_USER_SECRET, true);
        $signKey = hash_hmac('sha256', $this->REGION, $signKey, true);
        $signKey = hash_hmac('sha256', 'execute-api', $signKey, true);
        $signKey = hash_hmac('sha256', 'aws4_request', $signKey, true);

        // Create a String-to-Sign, which indicates the hash that is used and
        // some data about the request, including the canonical request from above.
        $stringToSign = 'AWS4-HMAC-SHA256' . "\n"
        . $date . "\n"
        . $ymd . '/' . $this->REGION . '/execute-api/aws4_request' . "\n"
        . hash('sha256', $canonicalRequest);

        // Sign the string with the key, which will create the signature
        // you'll need for the authorization header.
        $signature = hash_hmac('sha256', $stringToSign, $signKey);

        // Create Authorization header, which is the final step. It does NOT use
        // newlines to separate the data; it is all one line, just broken up here
        // for easier reading.
        $authorization = 'AWS4-HMAC-SHA256 '
        . 'Credential=' . $this->IAM_USER_KEY . '/' . $ymd . '/'
        . $this->REGION . '/execute-api/aws4_request,'
        . 'SignedHeaders=host;user-agent;x-amz-access-token;x-amz-date,'
        . 'Signature=' . $signature;

        // Create the header array for the cURL request. The headers must be
        // in alphabetical order. You must include all of the headers that were
        // in the canonical request above, plus you add in the authorization header
        // and an optional content-type header (for POST requests with JSON payload).
        $headers = [];
        $headers[] = 'authorization:' . $authorization;
        if ($post) $headers[] = 'content-type:application/json;charset=utf-8';
        $headers[] = 'host:' . $this->HOST;
        $headers[] = 'user-agent:' . $this->USER_AGENT;
        $headers[] = 'x-amz-access-token:' . $accessToken;
        $headers[] = 'x-amz-date:' . $date;

        // Run the http request and capture the status code
        $status = '';
        $fullUrl = $this->ENDPOINT . $path . ($qs ? '?' . $qs : '');
        
        $result = $this->httpRequest($fullUrl, $post, $headers, $status); 

        // Validate the response
        //if (strpos($result, 'Error:') === 0) exit($result);
        //if (empty($result)) exit('Error: Empty response');
        //if ($status != 200) exit('Error: Status code ' . $status . ': ' . $result);
        //if (strpos($result, '{') !== 0) exit('Error: Invalid JSON: ' . $result);
        
        // Decode json and return it
        $json = json_decode($result, true);
        if (!$json) exit('Error: Problem decoding JSON: ' . $result);
        return $json;  
        
    }    
   
    // Use the 'getItemOffers' operation to get offers for a single ASIN
    function getOffersForAsin($asin) {
        $method = 'GET';
        $url = '/products/pricing/v0/items/' . $asin . '/offers';
        $qs = 'Asin=' . $asin . '&ItemCondition=New&MarketplaceId=' . $this->MP_ID;
        return $this->amazonRequest($method, $url, $qs);
    }
    
    function getOrders($offset_seconds){
        
        $createdafter = gmdate("Y-m-d\TH:i:s\Z", time()-$offset_seconds); 
        $method = 'GET';
        $url = '/orders/v0/orders';
        $qs = 'CreatedAfter='.$createdafter.'&MarketplaceIds=' . $this->MP_ID;
        return $this->amazonRequest($method, $url, $qs);   
       
    }
    
    function getOrderBySellerOrderId($SellerOrderId){
        $createdafter = gmdate("Y-m-d\TH:i:s\Z", time()-3000000); 
        $method = 'GET';
        $url = '/orders/v0/orders';
        $qs = 'CreatedAfter='.$createdafter.'&SellerOrderId='.$SellerOrderId.'&MarketplaceIds=' . $this->MP_ID;
        return $this->amazonRequest($method, $url, $qs);   
       
    }

    function getOrderDetails($orderid){
        
        $createdafter = gmdate("Y-m-d\TH:i:s\Z", time()-$offset_seconds); 
        
        $method = 'GET';
        $url = '/orders/v0/orders/'.$orderid;
        $qs = '';
        return $this->amazonRequest($method, $url, $qs);
    }
  
    function getOrderItems($orderid){
        
        //$createdafter = gmdate("Y-m-d\TH:i:s\Z", time()-$offset_seconds); 
        
        $method = 'GET';
        $url = '/orders/v0/orders/'.$orderid.'/orderItems';
        $qs = '';
        return $this->amazonRequest($method, $url, $qs);
    }    
    
     function getListingsItem($sellerid, $sku, $marketplaceid){
                
        $method = 'GET';
        $url = '/listings/2021-08-01/items/'.$sellerid.'/'.$sku;
        $qs = 'marketplaceIds='.$marketplaceid;
        return $this->amazonRequest($method, $url, $qs);
    }     
      
    function createReport(){
                
        $method = 'POST';
        $url = '/reports/2021-06-30/reports/';
        $qs = "body={'reportType'=>'GET_MERCHANT_LISTINGS_DATA', 'marketplaceIds'=>'ATVPDKIKX0DER'}";
        return $this->amazonRequest($method, $url, $qs);
    }    
        
    function getFeedDocument($feedDocumentId){
        
        $feedDocumentId = rawurldecode($feedDocumentId);
        $method = 'GET';
        $url = '/feeds/2021-06-30/documents/'.$feedDocumentId;
        $qs = 'marketplaceIds=ATVPDKIKX0DER';
        return $this->amazonRequest($method, $url, $qs);        
    }
    
    function createFeedDocument(){
// very important that content type maches 
// the content type in uploadXmlStringToSpApi  
        $method = 'POST'; 
        $url = '/feeds/2021-06-30/documents'; 
        $qs = '';
        $post = '{"contentType": "text/xml; charset=UTF-8;"}'; 
        //$post = 'contentType: "text/xml'; 
        echo 'one';
        $response = $this->amazonRequest($method, $url, $qs, $post); 
        echo 'two ';
        return $response;
    }       
   
    function createFeedDG($documentId){

        $documentId = rawurldecode($documentId);
        $marketplaceId = $this->MP_ID;
        
        $method = 'POST'; 
        $url = '/feeds/2021-06-30/feeds'; 
        $qs = ''; 
        $post = '{"feedType": "POST_ORDER_FULFILLMENT_DATA", "marketplaceIds": ["'.$marketplaceId.'"], "inputFeedDocumentId":"'.$documentId.'"}'; 

        $response = $this->amazonRequest($method, $url, $qs, $post); 
        
        return $response;
        
    }

 
    function uploadXmlStringToSpApi($uploadUrl,$amazonOrderId,$trackingNumber) {
        // Initialize a cURL session
        $curl = curl_init();
        
        $uploadUrl = rawurldecode($uploadUrl);
        
        /*$xmlString = '<?xml version="1.0" encoding="utf-8"?>
        <AmazonEnvelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="amzn-envelope.xsd">
          <Header>
            <DocumentVersion>1.01</DocumentVersion>
            <MerchantIdentifier>YOURVALUE</MerchantIdentifier>
          </Header>
          <MessageType>Inventory</MessageType>
          <Message>
            <MessageID>1</MessageID>
            <OperationType>Update</OperationType>
            <Inventory>
              <SKU>YOURSKU</SKU>
              <Quantity>1</Quantity>
            </Inventory>
          </Message>
        </AmazonEnvelope>';*/ 
        
        
        $xmlString = '<?xml version="1.0" encoding="UTF-8"?>
        <AmazonEnvelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="amzn-envelope.xsd">
            <Header>
                <DocumentVersion>1.01</DocumentVersion>
                <MerchantIdentifier>A398RJD80G8ZFI</MerchantIdentifier>
            </Header>
            <MessageType>OrderFulfillment</MessageType>
            <Message>
                <MessageID>1</MessageID>
                <OperationType>Update</OperationType>
                <OrderFulfillment xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
                    <AmazonOrderID>'.$amazonOrderId.'</AmazonOrderID>
                    <FulfillmentData>
                        <CarrierCode>FedEx</CarrierCode>
                        <CarrierName>FedEx</CarrierName>
                        <ShippingMethod>FedEx Home Delivery®</ShippingMethod>
                        <ShipperTrackingNumber>'.$trackingNumber.'</ShipperTrackingNumber>
                    </FulfillmentData>
                </OrderFulfillment>
                </Message>
        </AmazonEnvelope>';
                
        // Set the options for the cURL session
        curl_setopt_array($curl, array(
            CURLOPT_URL => $uploadUrl, // The pre-signed URL obtained from createFeedDocument
            CURLOPT_CUSTOMREQUEST => 'PUT', // Specify the request method as PUT
            CURLOPT_POSTFIELDS => $xmlString, // Pass the XML string as the data to be uploaded
            CURLOPT_RETURNTRANSFER => true, // Return the transfer as a string
            CURLOPT_HTTPHEADER => array(
                'Content-Type: text/xml; charset=UTF-8;', // Specify the content type
                'Content-Length: ' . strlen($xmlString), // Specify the length of the XML string
            ),
        ));

        // Execute the cURL session
        $response = curl_exec($curl);
        $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE); // Get the HTTP status code

        // Close the cURL session
        curl_close($curl);
     
        // Check the response
        if ($httpCode == 200) {
            return "XML string uploaded successfully.";
        } else {
            return "Failed to upload XML string. HTTP status code: $httpCode";
        }
    } 
}

?>